package scenariodiagrameditor.features;

import org.eclipse.graphiti.features.ICreateFeature;
import org.eclipse.graphiti.features.IFeatureProvider;
import org.eclipse.graphiti.features.context.ICreateContext;
import org.eclipse.graphiti.features.impl.AbstractCreateFeature;
import org.eclipse.graphiti.mm.pictograms.Diagram;

import de.uks.se.scenariodiagram.ScenarioAttribute;
import de.uks.se.scenariodiagram.ScenarioObject;
import de.uks.se.scenariodiagram.ScenariodiagramFactory;

public class CreateScenarioObjectFeature extends AbstractCreateFeature implements ICreateFeature {

	private final String DEFAULT_TAG = "text";
	private final String DEFAULT_VALUE = "ScenarioObject";
	
	public CreateScenarioObjectFeature(IFeatureProvider fp) {
		super(fp, "ScenarioObject", "Creates a new ScenarioObject");
	}

	@Override
	public boolean canCreate(ICreateContext context) {
		return context.getTargetContainer() instanceof Diagram;
	}

	@Override
	public Object[] create(ICreateContext context) {
		ScenarioObject newScenarioObject = ScenariodiagramFactory.eINSTANCE.createScenarioObject();
		ScenarioAttribute newScenarioAttribute = ScenariodiagramFactory.eINSTANCE.createScenarioAttribute();
		newScenarioAttribute.setTag(DEFAULT_TAG);
		newScenarioAttribute.setValue(DEFAULT_VALUE);
		
		newScenarioObject.getAttributes().add(newScenarioAttribute);

		getDiagram().eResource().getContents().add(newScenarioObject);
		addGraphicalRepresentation(context, newScenarioObject);

		return new Object[] { newScenarioObject };
	}
}
